unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,winspool, StdCtrls,printers;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  ByteCnt : DWORD; //Nb d'octets  rserver pour rcuprer le tableau de structures
  StructCnt: DWORD; //Nb de structures rcuprees = nb imprimantes
  p : pointer; //pointe sur le tableau de structures retourn par EnumPrinters
  PrinterInfo: PPrinterInfo2; //Pointeur de structures de type _Printer_Info_2
  //Descriptif : http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdi/prntspol_9otu.asp
begin
Memo1.Clear;
//initialisation des paramtres
ByteCnt := 0;
StructCnt := 0;
PrinterInfo:=nil;
p:=nil;
//Cette fonction retourne un pointeur sur les structures des imprimantes
//Le While permet d'effectuer une rservation suffisante pour le tableau de structures
While not EnumPrinters(PRINTER_ENUM_LOCAL, nil, 2, p, ByteCnt, ByteCnt,StructCnt) Do
  Begin
  if (GetLastError = ERROR_INSUFFICIENT_BUFFER) then
    Begin
    p := AllocMem(ByteCnt);
    End;
  end;
//Maintenant il ne reste plus qu' lire le contenu des structures du tableau
For I:=0 To StructCnt-1 Do //On lit chaques structures propre  chaque imprimante
  Begin
  //On se dplace dans le tableau de structures
  PrinterInfo := PPrinterInfo2(LongInt(P)+I*sizeof(_Printer_Info_2));
  Memo1.lines.add(PrinterInfo.pPrinterName);
  Memo1.lines.add(#9+'Port          ->   '+PrinterInfo.pPortName);
  Memo1.lines.add(#9+'Pilote        ->   '+PrinterInfo.pDriverName);
  Memo1.lines.add(#9+'Commentaire   ->   '+PrinterInfo.pComment);
  End;
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
I: Integer;
buf : string;
ByteCnt, StructCnt: DWORD;
DriverDirectory: pchar;
begin
Memo1.Clear;
ByteCnt := 0;
DriverDirectory:=nil;
//Cette fonction retourne un pointeur chaine contenant le rpertoire en question
//Le While permet d'effectuer une rservation suffisante pour la chaine de caractres
While not GetPrinterDriverDirectory(nil,nil,1,DriverDirectory,ByteCnt, ByteCnt) Do
  Begin
  if (GetLastError = ERROR_INSUFFICIENT_BUFFER) then
    Begin
    DriverDirectory := AllocMem(ByteCnt);
    End;
  end;
Memo1.Lines.Add(DriverDirectory);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  I: Integer;
  ByteCnt : DWORD; //Nb d'octets  rserver pour rcuprer le tableau de structures
  StructCnt: DWORD; //Nb de structures rcuprees = nb de drivers
  p : pointer; //pointe sur le tableau de structures retourn par EnumPrinterDrivers
  DriverInfo: PDriverInfo3; //Pointeur de structures de type _Driver_Info_2
  //Descriptif : http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdi/prntspol_7egi.asp
begin
Memo1.Clear;
//initialisation des paramtres
ByteCnt := 0;
StructCnt := 0;
DriverInfo:=nil;
p:=nil;
//Cette fonction retourne un pointeur sur les structures des pilotes
//Le While permet d'effectuer une rservation suffisante pour le tableau de structures
While not EnumPrinterDrivers(nil, nil, 3, p, ByteCnt, ByteCnt,StructCnt) Do
  Begin
  if (GetLastError = ERROR_INSUFFICIENT_BUFFER) then
    Begin
    p := AllocMem(ByteCnt);
    End;
  end;
//Maintenant il ne reste plus qu' lire le contenu des structures du tableau
For I:=0 To StructCnt-1 Do //On lit chaques structures propre  chaque pilote
  Begin
  //On se dplace dans le tableau de structures
  DriverInfo := PDriverInfo3(LongInt(P)+I*(sizeof(_Driver_Info_3)));
  Memo1.lines.add('');
  Memo1.lines.add(DriverInfo.pName);
  Memo1.lines.add(#9+'Environnement (type d''OS)             ->   '+DriverInfo.pEnvironment);
  Memo1.lines.add(#9+'Chemin du pilote                       ->   '+DriverInfo.pDriverPath);
  Memo1.lines.add(#9+'Chemin des donnes du pilote           ->   '+DriverInfo.pDataFile);
  Memo1.lines.add(#9+'Chemin du fichier de conf. du pilote   ->   '+DriverInfo.pConfigFile);
  Memo1.lines.add(#9+'Chemin du fichier d''aide              ->   '+DriverInfo.pHelpFile);
  Memo1.lines.add(#9+'Fichiers supp. dont dpend le pilote   ->   '+DriverInfo.pDependentFiles);
  End;
end;



end.
